"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import google.protobuf.descriptor
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import typing
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _VtsiProjectStatus:
    ValueType = typing.NewType('ValueType', builtins.int)
    V: typing_extensions.TypeAlias = ValueType
class _VtsiProjectStatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_VtsiProjectStatus.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    UNSPECIFIED: _VtsiProjectStatus.ValueType  # 0
    """No status specified"""

    UNDEPLOYED: _VtsiProjectStatus.ValueType  # 1
    """Project successfully created and undeployed"""

    UPDATING: _VtsiProjectStatus.ValueType  # 2
    """Project configuration is updating"""

    DEPLOYING: _VtsiProjectStatus.ValueType  # 3
    """Project is deploying"""

    DEPLOYED: _VtsiProjectStatus.ValueType  # 4
    """Project is deployed"""

    UNDEPLOYING: _VtsiProjectStatus.ValueType  # 5
    """Project is un-deploying"""

    DELETING: _VtsiProjectStatus.ValueType  # 6
    """Project is currently deleting"""

    DELETED: _VtsiProjectStatus.ValueType  # 7
    """Project is deleted"""

class VtsiProjectStatus(_VtsiProjectStatus, metaclass=_VtsiProjectStatusEnumTypeWrapper):
    """Status of a VtsiProject."""
    pass

UNSPECIFIED: VtsiProjectStatus.ValueType  # 0
"""No status specified"""

UNDEPLOYED: VtsiProjectStatus.ValueType  # 1
"""Project successfully created and undeployed"""

UPDATING: VtsiProjectStatus.ValueType  # 2
"""Project configuration is updating"""

DEPLOYING: VtsiProjectStatus.ValueType  # 3
"""Project is deploying"""

DEPLOYED: VtsiProjectStatus.ValueType  # 4
"""Project is deployed"""

UNDEPLOYING: VtsiProjectStatus.ValueType  # 5
"""Project is un-deploying"""

DELETING: VtsiProjectStatus.ValueType  # 6
"""Project is currently deleting"""

DELETED: VtsiProjectStatus.ValueType  # 7
"""Project is deleted"""

global___VtsiProjectStatus = VtsiProjectStatus


class VtsiProject(google.protobuf.message.Message):
    """The VTSI project with its configuration setting"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    DISPLAY_NAME_FIELD_NUMBER: builtins.int
    MAX_CALLERS_FIELD_NUMBER: builtins.int
    MAX_LISTENERS_FIELD_NUMBER: builtins.int
    ASTERISK_CONFIGS_FIELD_NUMBER: builtins.int
    VTSI_PROJECT_STATUS_FIELD_NUMBER: builtins.int
    CREATED_BY_FIELD_NUMBER: builtins.int
    CREATED_AT_FIELD_NUMBER: builtins.int
    MODIFIED_BY_FIELD_NUMBER: builtins.int
    MODIFIED_AT_FIELD_NUMBER: builtins.int
    name: typing.Text
    """Required. The project name. Format: <pre><code>projects/&lt;project_uuid&gt;/project</code></pre>
    Only when a new VtsiProject is created the name can be undefined/empty
    """

    display_name: typing.Text
    """OPTIONAL: The display name of the project"""

    max_callers: builtins.int
    """The maximum number of callers that this project can have."""

    max_listeners: builtins.int
    """The maximum number of listeners that this project can have."""

    @property
    def asterisk_configs(self) -> global___AsteriskConfigs:
        """Configs to start the asterisk server."""
        pass
    vtsi_project_status: global___VtsiProjectStatus.ValueType
    created_by: typing.Text
    """The user who created the vtsi project. Readonly."""

    @property
    def created_at(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Creation time of the vtsi project. Readonly."""
        pass
    modified_by: typing.Text
    """The user who modified the vtsi project. Readonly."""

    @property
    def modified_at(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Modification time of the vtsi project. Readonly."""
        pass
    def __init__(self,
        *,
        name: typing.Text = ...,
        display_name: typing.Text = ...,
        max_callers: builtins.int = ...,
        max_listeners: builtins.int = ...,
        asterisk_configs: typing.Optional[global___AsteriskConfigs] = ...,
        vtsi_project_status: global___VtsiProjectStatus.ValueType = ...,
        created_by: typing.Text = ...,
        created_at: typing.Optional[google.protobuf.timestamp_pb2.Timestamp] = ...,
        modified_by: typing.Text = ...,
        modified_at: typing.Optional[google.protobuf.timestamp_pb2.Timestamp] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["asterisk_configs",b"asterisk_configs","created_at",b"created_at","modified_at",b"modified_at"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["asterisk_configs",b"asterisk_configs","created_at",b"created_at","created_by",b"created_by","display_name",b"display_name","max_callers",b"max_callers","max_listeners",b"max_listeners","modified_at",b"modified_at","modified_by",b"modified_by","name",b"name","vtsi_project_status",b"vtsi_project_status"]) -> None: ...
global___VtsiProject = VtsiProject

class AsteriskConfigsVariables(google.protobuf.message.Message):
    """Configuration variables for the Asterisk server"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    SIP_TRUNK_USERNAME_FIELD_NUMBER: builtins.int
    SIP_TRUNK_PASSWORD_FIELD_NUMBER: builtins.int
    SIP_TRUNK_HOST_FIELD_NUMBER: builtins.int
    TRANSFER_NUMBER_FIELD_NUMBER: builtins.int
    TRANSFER_NUMBER_HOST_FIELD_NUMBER: builtins.int
    SIP_TRUNK_PHONE_NUMBER_FIELD_NUMBER: builtins.int
    sip_trunk_username: typing.Text
    """SIP trunk username."""

    sip_trunk_password: typing.Text
    """SIP trunk password."""

    sip_trunk_host: typing.Text
    """SIP trunk host."""

    transfer_number: typing.Text
    """Transfer number."""

    transfer_number_host: typing.Text
    """Transfer number host."""

    sip_trunk_phone_number: typing.Text
    """SIP trunk phone number."""

    def __init__(self,
        *,
        sip_trunk_username: typing.Text = ...,
        sip_trunk_password: typing.Text = ...,
        sip_trunk_host: typing.Text = ...,
        transfer_number: typing.Text = ...,
        transfer_number_host: typing.Text = ...,
        sip_trunk_phone_number: typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["sip_trunk_host",b"sip_trunk_host","sip_trunk_password",b"sip_trunk_password","sip_trunk_phone_number",b"sip_trunk_phone_number","sip_trunk_username",b"sip_trunk_username","transfer_number",b"transfer_number","transfer_number_host",b"transfer_number_host"]) -> None: ...
global___AsteriskConfigsVariables = AsteriskConfigsVariables

class AsteriskConfigsFiles(google.protobuf.message.Message):
    """Configuration files for the Asterisk server"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    SIP_CONF_FILE_STRING_FIELD_NUMBER: builtins.int
    EXTENSIONS_CONF_FILE_STRING_FIELD_NUMBER: builtins.int
    QUEUES_CONF_FILE_STRING_FIELD_NUMBER: builtins.int
    MODULES_CONF_FILE_STRING_FIELD_NUMBER: builtins.int
    sip_conf_file_string: typing.Text
    """sip.conf file as string"""

    extensions_conf_file_string: typing.Text
    """extensions.conf file as string"""

    queues_conf_file_string: typing.Text
    """queues.conf file as string"""

    modules_conf_file_string: typing.Text
    """modules.conf file as string"""

    def __init__(self,
        *,
        sip_conf_file_string: typing.Text = ...,
        extensions_conf_file_string: typing.Text = ...,
        queues_conf_file_string: typing.Text = ...,
        modules_conf_file_string: typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["extensions_conf_file_string",b"extensions_conf_file_string","modules_conf_file_string",b"modules_conf_file_string","queues_conf_file_string",b"queues_conf_file_string","sip_conf_file_string",b"sip_conf_file_string"]) -> None: ...
global___AsteriskConfigsFiles = AsteriskConfigsFiles

class AsteriskConfigs(google.protobuf.message.Message):
    """Configurations object for the Asterisk server"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    ASTERISK_CONFIGS_VARIABLES_FIELD_NUMBER: builtins.int
    ASTERISK_CONFIGS_FILES_FIELD_NUMBER: builtins.int
    ASTERISK_CONFIGS_TARGET_DIRECTORY_NAME_FIELD_NUMBER: builtins.int
    ASTERISK_PORT_FIELD_NUMBER: builtins.int
    @property
    def asterisk_configs_variables(self) -> global___AsteriskConfigsVariables:
        """Configs as variables which will fill those variables using a blue print."""
        pass
    @property
    def asterisk_configs_files(self) -> global___AsteriskConfigsFiles:
        """Configs as files which will set up the configs using those files."""
        pass
    asterisk_configs_target_directory_name: typing.Text
    """Configs will be mapped in from a preconfigured asterisk target directory."""

    asterisk_port: builtins.int
    """OPTIONAL: The port where Asterisk should start."""

    def __init__(self,
        *,
        asterisk_configs_variables: typing.Optional[global___AsteriskConfigsVariables] = ...,
        asterisk_configs_files: typing.Optional[global___AsteriskConfigsFiles] = ...,
        asterisk_configs_target_directory_name: typing.Text = ...,
        asterisk_port: builtins.int = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["asterisk_configs_files",b"asterisk_configs_files","asterisk_configs_oneof",b"asterisk_configs_oneof","asterisk_configs_target_directory_name",b"asterisk_configs_target_directory_name","asterisk_configs_variables",b"asterisk_configs_variables"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["asterisk_configs_files",b"asterisk_configs_files","asterisk_configs_oneof",b"asterisk_configs_oneof","asterisk_configs_target_directory_name",b"asterisk_configs_target_directory_name","asterisk_configs_variables",b"asterisk_configs_variables","asterisk_port",b"asterisk_port"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["asterisk_configs_oneof",b"asterisk_configs_oneof"]) -> typing.Optional[typing_extensions.Literal["asterisk_configs_variables","asterisk_configs_files","asterisk_configs_target_directory_name"]]: ...
global___AsteriskConfigs = AsteriskConfigs

class CreateVtsiProjectRequest(google.protobuf.message.Message):
    """Request for creating a VTSI project"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    VTSI_PROJECT_FIELD_NUMBER: builtins.int
    ERROR_MESSAGE_FIELD_NUMBER: builtins.int
    @property
    def vtsi_project(self) -> global___VtsiProject:
        """VTSI project
        Recommended is to leave "name" empty. The project name here is optional.
        If no name is given a new parent name is created. The parent has the format:
        <pre><code>projects/&lt;project_uuid&gt;/project</code></pre>.
        """
        pass
    error_message: typing.Text
    """error message if there are any."""

    def __init__(self,
        *,
        vtsi_project: typing.Optional[global___VtsiProject] = ...,
        error_message: typing.Text = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["vtsi_project",b"vtsi_project"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["error_message",b"error_message","vtsi_project",b"vtsi_project"]) -> None: ...
global___CreateVtsiProjectRequest = CreateVtsiProjectRequest

class CreateVtsiProjectResponse(google.protobuf.message.Message):
    """Response of the create project"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    VTSI_PROJECT_FIELD_NUMBER: builtins.int
    ERROR_MESSAGE_FIELD_NUMBER: builtins.int
    @property
    def vtsi_project(self) -> global___VtsiProject:
        """Vtsi project"""
        pass
    error_message: typing.Text
    """error message if there are any."""

    def __init__(self,
        *,
        vtsi_project: typing.Optional[global___VtsiProject] = ...,
        error_message: typing.Text = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["vtsi_project",b"vtsi_project"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["error_message",b"error_message","vtsi_project",b"vtsi_project"]) -> None: ...
global___CreateVtsiProjectResponse = CreateVtsiProjectResponse

class GetVtsiProjectRequest(google.protobuf.message.Message):
    """Request to retrieve a VTSI project"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    name: typing.Text
    """VTSI project name with which to perform the call of the form <pre><code>projects/&lt;project_uuid&gt;/project</code></pre>"""

    def __init__(self,
        *,
        name: typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["name",b"name"]) -> None: ...
global___GetVtsiProjectRequest = GetVtsiProjectRequest

class UpdateVtsiProjectRequest(google.protobuf.message.Message):
    """Request to updated VTSI project"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    VTSI_PROJECT_FIELD_NUMBER: builtins.int
    @property
    def vtsi_project(self) -> global___VtsiProject:
        """Project Configs."""
        pass
    def __init__(self,
        *,
        vtsi_project: typing.Optional[global___VtsiProject] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["vtsi_project",b"vtsi_project"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["vtsi_project",b"vtsi_project"]) -> None: ...
global___UpdateVtsiProjectRequest = UpdateVtsiProjectRequest

class UpdateVtsiProjectResponse(google.protobuf.message.Message):
    """Request to updated VTSI project"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    ERROR_MESSAGE_FIELD_NUMBER: builtins.int
    name: typing.Text
    """VTSI project name with which to perform the call of the form <pre><code>projects/&lt;project_uuid&gt;/project</code></pre>"""

    error_message: typing.Text
    """error message if there are any."""

    def __init__(self,
        *,
        name: typing.Text = ...,
        error_message: typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["error_message",b"error_message","name",b"name"]) -> None: ...
global___UpdateVtsiProjectResponse = UpdateVtsiProjectResponse

class DeleteVtsiProjectRequest(google.protobuf.message.Message):
    """Request to delete a VTSI project
    If a deployed VTSI project was deleted then it was undeployed beforehand automatically
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    name: typing.Text
    """VTSI project name with which to perform the call of the form <pre><code>projects/&lt;project_uuid&gt;/project</code></pre>"""

    def __init__(self,
        *,
        name: typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["name",b"name"]) -> None: ...
global___DeleteVtsiProjectRequest = DeleteVtsiProjectRequest

class DeleteVtsiProjectResponse(google.protobuf.message.Message):
    """Response to delete a VTSI project
    If a deployed VTSI project was deleted then it was undeployed beforehand automatically
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    ERROR_MESSAGE_FIELD_NUMBER: builtins.int
    name: typing.Text
    """VTSI project name with which to perform the call of the form <pre><code>projects/&lt;project_uuid&gt;/project</code></pre>"""

    error_message: typing.Text
    """error message if there are any."""

    def __init__(self,
        *,
        name: typing.Text = ...,
        error_message: typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["error_message",b"error_message","name",b"name"]) -> None: ...
global___DeleteVtsiProjectResponse = DeleteVtsiProjectResponse

class DeployVtsiProjectRequest(google.protobuf.message.Message):
    """Request to deploy a vtsi project"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    name: typing.Text
    """VTSI project name with which to perform the call of the form <pre><code>projects/&lt;project_uuid&gt;/project</code></pre>"""

    def __init__(self,
        *,
        name: typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["name",b"name"]) -> None: ...
global___DeployVtsiProjectRequest = DeployVtsiProjectRequest

class DeployVtsiProjectResponse(google.protobuf.message.Message):
    """Response to deploy a vtsi project"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    ERROR_MESSAGE_FIELD_NUMBER: builtins.int
    name: typing.Text
    """VTSI project name with which to perform the call of the form <pre><code>projects/&lt;project_uuid&gt;/project</code></pre>"""

    error_message: typing.Text
    """error message if there are any."""

    def __init__(self,
        *,
        name: typing.Text = ...,
        error_message: typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["error_message",b"error_message","name",b"name"]) -> None: ...
global___DeployVtsiProjectResponse = DeployVtsiProjectResponse

class UndeployVtsiProjectRequest(google.protobuf.message.Message):
    """ Request to undeploy a vtsi project"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    name: typing.Text
    """Project name of the VTSI project."""

    def __init__(self,
        *,
        name: typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["name",b"name"]) -> None: ...
global___UndeployVtsiProjectRequest = UndeployVtsiProjectRequest

class UndeployVtsiProjectResponse(google.protobuf.message.Message):
    """Response to undeploy a vtsi project"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    NAME_FIELD_NUMBER: builtins.int
    ERROR_MESSAGE_FIELD_NUMBER: builtins.int
    name: typing.Text
    """VTSI project name with which to perform the call of the form <pre><code>projects/&lt;project_uuid&gt;/project</code></pre>"""

    error_message: typing.Text
    """error message if there are any."""

    def __init__(self,
        *,
        name: typing.Text = ...,
        error_message: typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["error_message",b"error_message","name",b"name"]) -> None: ...
global___UndeployVtsiProjectResponse = UndeployVtsiProjectResponse
